%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PVC:SYS-CONSTS.SL
% Description:  VAX PSL constants needed in the compiler
% Author:       Cris Perdue
% Created:      24-Feb-84
% Modified:     27-Dec-84 (Brian Beach)
% Mode:         Lisp
% Package:      
% Status:       Experimental (Do Not Distribute)
%
% (c) Copyright 1984, Hewlett-Packard Company, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
%
%  November 27 1991 Winfried Neun , ZIB Berlin
%  modified system list for HP-Risc
%
%  july 7 1988 (chris burdorf)
%  modified system list for SPARC
%
%  December 8 1988 Winfried Neun , ZIB Berlin
%  modified system list for SPARC
%
% 27-Dec-84 (Brian Beach)
%  Increased the size of BPS to accomodate NMODE 2.0.
% 28 Mar 1984 1717-PST (Nancy Kendzierski)
%  Added declare-wconst of faslin-magic and faslout-magic.
%  Vax Unix = 199 and 199
% 28 Feb 1984 1341-PST (Cris Perdue)
%  Added maxargs and maxrealregs to this file from global-data.
% 21 Feb 1984 1217-PST (Nancy Kendzierski)
%  Added remprop of 'wconst properties to ensure the new declarations will
%  take effect.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

(imports '(tags))

(fluid '(system_list*))

(setq system_list* '(HP-Risc Unix HP-UX spectrum snake IEEE))

(define-constant faslin-magic  199)
(define-constant faslout-magic 199)

(define-constant tagstartingbit                  0)
(define-constant tagbitlength                    5)
(define-constant infstartingbit                  5)
(define-constant infbitlength                   27)
(define-constant addressingunitsperitem  4)
(define-constant charactersperword               4)
(define-constant bitsperword                    32)
(define-constant bitsperword2                   16)
(define-constant stackdirection                 -1)
(define-constant addressingunitsperfunctioncell  4)


(define-constant maxrealregs  5)
(define-constant maxargs      15)

% At present this is the single machine-dependent character
% (for ASCII machines).  Defined here in case cross-compilation
% is being done.  Defined for the kernel in pv:scan-table.sl. /csp
(put 'eof 'charconst (char (control d)))

(define-constant stacksize             20000)
(define-constant bndstksize            2000)
(define-constant compressedbinaryradix 16)
(define-constant maxtokensize          5000)
(define-constant catchstacksize        400)
(define-constant hash-table-size       18013)
(define-constant maxsymbols            15000)
%(define-constant heapsize              800000)  % These are now taken care of
%(define-constant bpssize               500000)  % by $pv/bpsheap.c

% End of file.
