%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXNK:DUMPLISP.SL
% Description:  Dump running lisp to an a.out format file.
% Author:       RAM, HP/FSD
% Created:      27-Feb-84
% Modified:     14-Jan-85 09:10:20 (Vicki O'Day)
% Package:
%
% (c) Copyright 1987, University of Utah, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Revisions:
% 31-Aug-88 (Julian Padget)
%  Changed second "fluid" call to "global" since there was no need of former.

(fluid '(symbolfilename* gcknt* gctime* ))

(global '(nextbps heaplast heapupperbound oldheapupperbound stacklowerbound))

(compiletime (flag '(dumplispaux ) 'internalfunction))

(de dumplisp (filename)
  (dumplispaux filename nextbps heaplast))

(de dumplispaux (filename data-start bss-start)
  (prog (savedstacklowerbound unexecresult savedunixargs x28 a1 a2)
        (setq x28 28)
        (unless (stringp filename)
          (stderror "Dumplisp requires a filename argument"))
        (reclaim)
    (if (unboundp 'gcarraylowerbound)
      (if (wgreaterp heapupperbound oldheapupperbound)
        (reclaim)))
(putto heaplowerbound)
        (setq savedstacklowerbound stacklowerbound)
    (setq savedunixargs unixargs*)    % Force each new system to get
    (setq unixargs* nil)              % its own args
        % must be 0 for a new file
        (setq gcknt* 0 gctime* 0)
        (setq unexecresult (binaryopenwrite (bldmsg "%w.img" filename)))
        (setq heaplastsave heaplast)
        
        (binarywriteblock unexecresult (datetag) 4)
        (binarywrite unexecresult (wtimes2 (wtimes2 addressingunitsperitem 5)
					 66000))
        (binarywrite unexecresult
                (Wplus2 (wdifference heaplast heaplowerbound) 24))
	(binarywrite unexecresult (wtimes2 8 2048))
        (binarywrite unexecresult  150000)
(setq a1 nextbps) (setq a2 bpslowerbound)
        (binarywrite unexecresult (wdifference a1 a2))
        (binarywrite unexecresult lastbps)
        (binarywrite unexecresult (wdifference (wplus2 a2 (unexec))
                                        lastbps))
        (binarywrite unexecresult heaplowerbound)
        (binarywriteblock unexecresult SYMVAL (wtimes2 5 66000))
(setq a1 heaplast) (setq a2 heaplowerbound)
        (binarywriteblock unexecresult heaplowerbound
                (wshift (wplus2 (wdifference a1 a2) 24) -3))
        (binarywriteblock unexecresult vivarea 2048)
	(binarywriteblock unexecresult hashtable (wquotient 150000 8))
(setq a1 nextbps) (setq a2 bpslowerbound)
        (binarywriteblock unexecresult bpslowerbound
                (wquotient (wdifference a1 a2) %(nextbps bpslowerbound)
			    addressingunitsperitem))
        (binarywriteblock unexecresult lastbps
           (wquotient (wdifference (wplus2 bpslowerbound (unexec))
                        lastbps) addressingunitsperitem))
        (binaryclose unexecresult)
        (setq stacklowerbound savedstacklowerbound)
))

(de putto (x) (wputv SYMVAL (id2int 'heaplowerbound) x))

%% End of File.
