%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PXU:makeutil.SL
% Mode:         Lisp
% Package:
% Status:       Experimental (Do Not Distribute)
% Compiletime:  PL:IF.B PL:SYS-CONSTS.B
% Runtime:      PL:SYS-CONSTS.B
%
% (c) Copyright 1984, Hewlett-Packard Company, all rights reserved.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
(de make-pnk-lap (name)
	(setq loaddirectories* '("psl.lap(%w)" "nonkern.lap(%w)" "%w.b"))
	(off usermode)

%% For machines that require the carcdr.sl fix for car/cdr of NIL, make sure
%% we turn on fastcar to ensure optimized code. Since PSL was written with
%% the assumption that car/car of NIL was illegal, it is not necessary
%% to generate code to test for this, slowing down all car/cdr operations
%% in the process. For user code though, it defaults to off for safety.
	(on fastcar)
	(setq *syslisp t)
        (faslout (bldmsg "nonkern.lap(%w)" name))
	(dskin (bldmsg "nonkern.sl(%w)" name)) 
	(faslend)
)

(de make-lap (name dir)
        (setq loaddirectories* '("psl.lap(%w)" "%w.b"))
        (off usermode)

%% For machines that require the carcdr.sl fix for car/cdr of NIL, make sure
%% we turn on fastcar to ensure optimized code. Since PSL was written with
%% the assumption that car/car of NIL was illegal, it is not necessary
%% to generate code to test for this, slowing down all car/cdr operations
%% in the process. For user code though, it defaults to off for safety.
        (on fastcar)
        (setq *syslisp t)
        (faslout (bldmsg "psl.lap(%w)" name))
        (dskin (bldmsg "%w.sl(%w)" dir name))
        (faslend)
)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% File:         PU:WRAPPERS.SL 
% Description:  A wrapper facility for PSL 
% Author:       Cris Perdue, Hewlett-Packard Laboratories 
% Created:      13-Mar-84 
% Modified:     21-Dec-84 10:28:24 (Lucy Berlin) 
% Mode:         Lisp 
% Package:      
% Status:       Experimental (Do Not Distribute) 
% Compiletime:  PL:IF.B PL:SYS-CONSTS.B 
% Runtime:      PL:SYS-CONSTS.B 
%
% (c) Copyright 1984, Hewlett-Packard Company, all rights reserved.
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
